#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

vector<pair<int, int> > inputs;

int main() {
  int N, i, a, b, j;
  
  while (1) {
    scanf("%d", &N);
    if (!N) return 0;
    
    inputs.clear();
    
    for (i = 0; i < N; i++) {
      scanf("%d %d", &a, &b);
      inputs.push_back(make_pair(++a, b));
    }
    
    sort(inputs.begin(), inputs.end());
    
    printf("NUM 1\nADD\n");
    
    for (i = 0; i < N; i++) {
      printf("DUP\n");
    
      for (j = N - 1; j > i; j--)
        printf("NUM %d\nMOD\n", inputs[j].first);
    
      printf("NUM %d\nDIV\n", inputs[i].first);
      printf("NUM %d\nMUL\n", inputs[i].second);
      printf("SWP\n");
    }
  
    printf("POP\n");
    for (i = 0; i < N - 1; i++)
      printf("ADD\n");
    
    puts("END\n");
  }
  
  return 0;
}
